import os
from django.core.management.base import BaseCommand, CommandError
from django.conf import settings

URL_TEMPLATE = """from django.conf.urls.defaults import *

# urlpatterns = patterns('',
#     (),
#     )
"""

MODELS_TEMPLATE = """from django.db import models

# Create your models here."""

class Command(BaseCommand):
    help = "Creates a plugin directory structure for the given plugin name."
    args = "[plugin]"

    def handle(self, plugin, **options):
        plugin_dir = os.path.join(settings.BRIGHTWAY_ROOT_PATH, "plugins")
        if plugin in os.listdir(plugin_dir):
            raise CommandError, "Plugin %s already exists." % plugin
        if '.' in plugin:
            raise CommandError, "The character '.' is not allowed in plugin"+\
                " names"
        path = os.path.join(plugin_dir, plugin)
        try:
            os.mkdir(path)
            os.chdir(path)
            # init
            f = open("__init__.py", "w")
            f.write("")
            f.close()
            # urls
            f = open("urls.py", "w")
            f.write(URL_TEMPLATE)
            f.close()
            # media directory
            os.mkdir("media")
            # models
            f = open("models.py", "w")
            f.write(MODELS_TEMPLATE)
            f.close()
            # tests
            f = open("tests.py", "w")
            f.write("# Create your tests here.\n")
            f.close()
            # views
            f = open("views.py", "w")
            f.write("# Create your views here.\n")
            f.close()
            # views
            f = open("local_settings.py", "w")
            f.write("# Add your plugin-specific settings here\n")
            f.close()
            print "*" * 60
            print "\tPlugin '%s' created successfully." % plugin
            print "\tPlease add 'brightway.plugins.%s' to" % plugin
            print "\tyour INSTALLED_APPS in 'settings/local.py'."
            print "*" * 60
        except OSError, e:
            raise CommandError(e)
