import os
from django.core.management.base import BaseCommand
from django.conf import settings

class Command(BaseCommand):
    def handle(self, *args, **options):
        cache_dir = os.path.join(settings.BRIGHTWAY_ROOT_PATH, 
            'core/tests/cache/')
        logs_dir = os.path.join(settings.BRIGHTWAY_ROOT_PATH, 
            'core/tests/logs/')

        def tar_file_filter(x):
            if x[-4:].lower() == ".tar":
                return True
            else:
                return False

        def log_file_filter(x):
            if x[-4:].lower() == ".log":
                return True
            else:
                return False

        for filename in filter(tar_file_filter, os.listdir(cache_dir)):
            os.remove(os.path.join(cache_dir, filename))

        for filename in filter(log_file_filter, os.listdir(logs_dir)):
            os.remove(os.path.join(logs_dir, filename))

