from django.contrib import admin
from django.utils.translation import ugettext_lazy as _
from brightway.apps.data_source.models import *

admin.site.register(Person)

class SourceAdmin(admin.ModelAdmin):
    save_on_top = True
    search_fields = ('title',)
    list_display = ('title', 'url', 'content_object', 'author_count')
    list_display_links = ('title',)
    ordering = ('content_type', 'title')
    list_filter = ("content_type",)
    fieldsets = (
        (None, {
            'fields': (('title', 'file', 'link'), 'people', 
                ('content_type', 'object_id')),
            }
        ),
    )

admin.site.register(Source, SourceAdmin)

