from django.contrib.contenttypes import generic
from django.contrib import admin
from brightway.apps.group_permissions.models import GroupPermission

class GroupPermissionAdmin(admin.ModelAdmin):
    save_on_top = True
    list_display = ('content_object', 'permission', 'group')
    list_editable = ('permission', 'group')
    list_display_links = ('content_object',)
    ordering = ('content_type', 'object_id')
    fieldsets = (
        (None, {
            'fields': (('permission', 'group'), ('content_type', 'object_id')),
            }
        ),
    )

admin.site.register(GroupPermission, GroupPermissionAdmin)

class GroupPermissionAdminInline(generic.GenericStackedInline):
    model = GroupPermission
    max_num = 3
    fieldsets = (
        (None, {
            'fields': (('permission', 'group'),),
            }
        ),
    )
