from django.db import models
from brightway.apps.group_permissions.utils import \
    filter_queryset_by_permission

class PermissionManager(models.Manager):
    def open(self, user=None):
        return filter_queryset_by_permission(self.get_query_set(), 0, user)

    def usable(self, user=None):
        return filter_queryset_by_permission(self.get_query_set(), 1, user)

    def restricted(self, user=None):
        return filter_queryset_by_permission(self.get_query_set(), 2, user)

    def private(self, user=None):
        return filter_queryset_by_permission(self.get_query_set(), 3, user)

