class GeographyBiosphereError(StandardError):
    """Biosphere flows can't have non-null geographies - geography is inherited from the referencing process."""
    pass


class BiosphereFlowAlreadyExists(StandardError):
    """This biosphere flow in this database/category already exists."""
    pass


class UnfreezableProcess(StandardError):
    """This process can't be frozen."""
    pass


class FrozenOutput(StandardError):
    """An exchange can't be added, because the output is frozen."""
    pass


class FrozenParent(StandardError):
    """A child of a frozen process can't be created"""
    pass