from django.contrib.auth.models import Group
from django.contrib.contenttypes.models import ContentType
from brightway.apps.group_permissions.models import GroupPermission

def add_default_database_everyone_permission(sender, instance, created, 
        **kwargs):
    """Add default permission for group "Everyone", if not already set"""
    # instance is new Database object
    if not created:
        return
    db_type=ContentType.objects.get_for_model(instance)
    everyone = Group.objects.get(name="Everyone")
    if GroupPermission.objects.filter(group=everyone, object_id=instance.id, 
            content_type=db_type).exists():
        return
    GroupPermission.objects.create(group=everyone, object_id=instance.id, 
        content_type=db_type, permission=3)
    