from django.contrib.auth.models import Group, User
from django_dag.models import Graph
from brightway.apps.geo.models import GeographyDatabase, Geography
from brightway.tests.lca_test_case import LCATestCase

class DefaultTestCase(LCATestCase):
    '''Test defaults set up correctly.'''
    def test_inheritance_graph_exists(self):
        self.assertTrue(Graph.objects.filter(name="inheritance").exists())

    def test_parameter_graph_exists(self):
        self.assertTrue(Graph.objects.filter(name="parameter").exists())

    def test_database_graph_exists(self):
        self.assertTrue(Graph.objects.filter(name="database").exists())

    def test_global_gdb(self):
        """Test the the ``Global`` geography database set up properly"""
        qs = GeographyDatabase.objects.filter(database="Global")
        self.assertTrue(qs.exists())
        self.assertEqual(Geography.objects.filter(database=qs[0]
            ).count(), 1)
        self.assertEqual(Geography.objects.filter(geography="Global").count(), 
            1)
        self.assertEqual(Geography.objects.get(geography="Global"
            ).database.id, qs[0].id)

    def test_world_geography_database_exists(self):
        self.assertTrue(GeographyDatabase.objects.filter(database="World" 
            ).exists())

    def test_everyone_group_exists(self):
        self.assertTrue(Group.objects.filter(name="Everyone").exists())

    def test_importer_user_exists(self):
        self.assertTrue(User.objects.filter(username="Importer").exists())
