from django.contrib import admin
from brightway.apps.license.models import License
from brightway.apps.license.forms import LicenseForm
from django.utils.translation import ugettext_lazy as _

class LicenseAdmin(admin.ModelAdmin):
    form = LicenseForm
    fieldsets = (
        (None, {'fields': ('name',)}),
        (_("Text"), {'fields': ('summary', 'license_text', 'comment')}),
        (_("Details"), {'fields': ('url', 'version'), 
            'description': _("Version should be a numeric value, e.g. 1.0.2")}),
    )
    list_display = ('name', 'version')
    ordering = ('name',)
    save_on_top = True
    save_as = True
    search_fields = ('name', 'license', 'comment', 'summary')

admin.site.register(License, LicenseAdmin)
