from django.db import models
from django import forms
from django.utils.translation import ugettext_lazy as _
from brightway.apps.base.fields.automaticurlmodel import AutomaticURLModel

class License(AutomaticURLModel):
    """A license for a data set or data object."""
    name = models.TextField(_("name"))
    summary = models.TextField(_("summary"), blank=True)
    version = models.TextField(_("version"), blank=True, default="Unknown")
    license_text = models.TextField(_("license text"))
    # TODO: Add URL validator
    url = models.TextField(_("url"), blank=True)
    comment = models.TextField(_("comment"), blank=True)

    lookup_names = ["license", "version"]

    class Meta:
        verbose_name = _("license")
        verbose_name_plural = _("licenses")
        unique_together = ("name", "version")

    def __unicode__(self):
        return self.name

    @models.permalink
    def get_license_text_url(self):
        return ('license-text', (), self._url_dict)
