from django.db import IntegrityError

class MissingReferenceError(StandardError):
    """Formula text references an object that does not exist"""
    pass

class ScopeError(AttributeError):
    """A passed reference is not in the scope of the current object."""
    pass

class MisformedUUIDError(ValueError):
    """UUID not recognized by parser, probably because of incorrect form."""
    pass

class IllegalLocalVariable(ValueError):
    """Local variable references aren't allowed in global variables."""
    pass

class DuplicateGlobalVariable(IntegrityError):
    """Global variable names must be unique in a single database."""
    pass