# Borrowed shamelessly from 
# http://www.mahner.org/posts/separating-staff-and-user-accounts-in-djangos-admin/
from django.contrib import admin
from django.contrib.auth.admin import UserAdmin
from django.contrib.auth.models import User
from django.db.models import Q
from brightway.apps.users.models import Customer, Staff, GroupPetition
from brightway.apps.users.forms import UserCreationForm, UserChangeForm


class UserProfileAdmin(UserAdmin):
    form = UserChangeForm
    add_form = UserCreationForm


class GroupPetitionAdmin(admin.ModelAdmin):
    save_on_top = True
    search_fields = ('group',)
    list_display = ('group', 'petitioner', 'receiver')
    list_display_links = ('group',)
    ordering = ('group', 'petitioner', 'receiver')
    list_filter = ("group",)
    fieldsets = (
        (None, {
            'fields': (('group',), ('petitioner', 'receiver'), ('message',)) 
            }
        ),
    )


admin.site.register(GroupPetition, GroupPetitionAdmin)
admin.site.register(User, UserProfileAdmin)
