from django.contrib.auth.models import User, Group
from django.db import models
from brightway.apps.base.fields.uuidfield import UUIDField


class GroupPetition(models.Model):
    petitioner = models.ForeignKey(User, related_name="group_petitioner")
    receiver = models.ForeignKey(User, related_name="group_receiver")
    group = models.ForeignKey(Group)
    message = models.TextField(blank=True)
    uuid = UUIDField()

    class Meta:
        unique_together = ('petitioner', 'group')

    def __unicode__(self):
        return u"Group petition from %s to join %s" % (self.petitioner, 
            self.group)

