from django.contrib.auth.models import Group
from brightway.apps.inventory.models import Database

def add_everyone_group(sender, instance, created, **kwargs):
    # instance is new User object
    if created:
        # Will be created if superuser is created via first syncdb call
        everyone = Group.objects.get_or_create(name="Everyone")[0]
        instance.groups.add(everyone)

def create_user_database(sender, instance, created, **kwargs):
    # instance is new User object
    if created:
        Database.objects.create(database=instance.username, 
            creator=instance)
    