from django.contrib.auth.models import User, Group
from brightway.tests.base_test_case import BaseTestCase
from brightway.apps.inventory.models import Database


class UserSignalsTest(BaseTestCase):
    def test_add_everyone_group(self):
        """Test that a new user belongs (only) to the 'Everyone' group."""
        frank = User.objects.create_user("Frank", "a@a.com", "password")
        self.assertEqual(frank.groups.all().count(), 1)
        self.assertEqual(frank.groups.all()[0], 
            Group.objects.get(name="Everyone"))

    def test_add_user_database(self):
        """Test that adding a User creates a new database."""
        frank = User.objects.create_user("Frank", "a@a.com", "password")
        self.assertEqual(Database.objects.all().count(), 1)
        self.assertEqual(Database.objects.filter(database="Frank").count(), 1)
        self.assertEqual(Database.objects.filter(creator=frank).count(), 1)
