with recursive exchange_recursive (
    intermediate_parent_id, 
    exchange_output_id,
    input_id, 
    output_id, 
    level
    ) as (
    select starting_table.parent_id, e.output_id, e.input_id, starting_table.id, 0
        from inventory_process starting_table
        left join inventory_exchange e
            on starting_table.id = e.output_id
        left join inventory_process input
            on input.id = e.input_id
        where starting_table.database_id in %s
        and starting_table.process_type <> 3 -- Frozen type
    union all
    select recursed_table.parent_id, e.output_id, e.input_id, exchange_recursive.output_id, exchange_recursive.level + 1
        from exchange_recursive, inventory_process recursed_table
        left join inventory_exchange e
            on recursed_table.id = e.output_id
        left join inventory_process input
            on input.id = e.input_id
        where recursed_table.id = exchange_recursive.intermediate_parent_id
        and recursed_table.database_id in %s
        and recursed_table.process_type <> 3 -- No inheritance from frozen
    )
select count( distinct (input_id, output_id)) 
    from exchange_recursive
    where input_id is not null
    and output_id is not null
