with recursive weighting_recursive (
    weighting_id,
    process_id, 
    intermediate_parent_id, 
    level
    ) as (
    select w.id, starting_table.id, starting_table.parent_id, 0, w.geography_id
        from inventory_process starting_table
        left join ia_weighting w
            on starting_table.id = w.process_id
        where starting_table.process_type in %s
        and (w.method_id = %s or w.method_id is null)
        and (w.geography_id = %s or w.geography_id is null)
    union all
    select w.id, weighting_recursive.process_id, recursed_table.parent_id, weighting_recursive.level + 1, w.geography_id
        from weighting_recursive, inventory_process recursed_table
        left join ia_weighting w
            on recursed_table.id = w.process_id
        where recursed_table.id = weighting_recursive.intermediate_parent_id
        and (w.method_id = %s or w.method_id is null)
        and (w.geography_id = %s or w.geography_id is null)
    )
select count ( distinct process_id) 
    from weighting_recursive
    where weighting_id is not null