import os
import datetime

def check_if_expired(filepath, dt):
    """Check is last file modification was before dt (datetime.datetime). 

Returns true if cache file is older than dt. Assumes 'filepath' references an 
actual filepath."""
    if not isinstance(dt, datetime.datetime):
        raise ValueError, "dt must be a datetime.datetime"
    try:
        last_modified = datetime.datetime.fromtimestamp(os.stat(filepath
            ).st_mtime)
    except OSError:
        return False
    if last_modified < dt:
        return True
    else:
        return False
