# -*- coding: utf-8 -*
try:
    from hashlib import md5 as universal_hash
except ImportError:
    from md5 import new as universal_hash

def generate_safe_hash(string):
    # If string is a "str", then it is bytes - translate to unencoded unicode
    if isinstance(string, str):
        # This could be the incorrect encoding, but that is OK - it only needs to be consistent.
        string = unicode(string, 'utf8')
    # Translate from unicode object to bytes so md5 doesn't commit suicide
    string = string.encode('utf8')
    return universal_hash(string).hexdigest()

if __name__ == "__main__":
    a = "ö"
    b = u"ö"
    c = '\xc3\xb6'
    assert generate_safe_hash(a) == generate_safe_hash(b) == generate_safe_hash(c)