import zipfile
from cStringIO import StringIO
import time

def zipfile_from_buffers(data):
    """
Create a in-memory zipfile from a set of (filename, cString buffer) tuples. 

Note that the cString buffer must be already encoded, e.g. in utf-8.
    """
    buffer_ = StringIO()
    z = zipfile.ZipFile(buffer_, "w")
    for name, bytes in data:
        info = zipfile.ZipInfo(name)
        info.date_time = time.localtime(time.time())[:6]
        info.compress_type = zipfile.ZIP_DEFLATED
        info.external_attr = 0666 << 16L
        z.writestr(info, bytes)
    z.close()
    buffer_.flush() # Does this do anything?
    zipped = buffer_.getvalue()
    buffer_.close()
    return zipped

if __name__ == "__main__":
    a = StringIO()
    b = StringIO()
    a.write("abcdefg")
    b.write("abcdefg")
    a.flush()
    # a.seek(0)
    b.seek(0)
    # print a.getvalue()
    # print b.read()
    data = (("a", a.getvalue()), ("b", b.read()))
    f = open("test_zip_file.zip", "wb")
    z = zipfile_from_buffers(data)
    f.write(z)
    f.close()
    