# -*- coding: utf-8 -*
from brightway.apps.geo.models import *
from brightway.apps.geo.polygons import merge_polygons
# from brightway.apps.geo.utils import merge_polygon_geographies

"""Merge countries to form UN regions, continents, and EcoSpold-specific geographies"""

step_one = ({'components': {'buffer': 0.0001,
             'components': [(u'0c33b64c-7d7e-11de-9ae2-0019e336be3a',
                             u'Burundi'),
                            (u'0cc14d18-7d7e-11de-9ae2-0019e336be3a',
                             u'Comoros'),
                            (u'0d0167a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Djibouti'),
                            (u'0d2ed0a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Eritrea'),
                            (u'0d3920fe-7d7e-11de-9ae2-0019e336be3a',
                             u'Ethiopia'),
                            (u'0ef4e126-7d7e-11de-9ae2-0019e336be3a',
                             u'Kenya'),
                            (u'0f6066da-7d7e-11de-9ae2-0019e336be3a',
                             u'Madagascar'),
                            (u'0fd0c588-7d7e-11de-9ae2-0019e336be3a',
                             u'Malawi'),
                            (u'0f8a5012-7d7e-11de-9ae2-0019e336be3a',
                             u'Mauritius'),
                            (u'10207fa6-7d7e-11de-9ae2-0019e336be3a',
                             u'Mayotte'),
                            (u'0fc883d2-7d7e-11de-9ae2-0019e336be3a',
                             u'Mozambique'),
                            (u'117d1850-7d7e-11de-9ae2-0019e336be3a',
                             u'Reunion'),
                            (u'129718da-7d7e-11de-9ae2-0019e336be3a',
                             u'Rwanda'),
                            (u'12a65db8-7d7e-11de-9ae2-0019e336be3a',
                             u'Seychelles'),
                            (u'12e2e22e-7d7e-11de-9ae2-0019e336be3a',
                             u'Somalia'),
                            (u'13615776-7d7e-11de-9ae2-0019e336be3a',
                             u'Tanzania, United Republic Of'),
                            (u'13685c7e-7d7e-11de-9ae2-0019e336be3a',
                             u'Uganda'),
                            (u'147563fa-7d7e-11de-9ae2-0019e336be3a',
                             u'Zambia'),
                            (u'147cde5a-7d7e-11de-9ae2-0019e336be3a',
                             u'Zimbabwe')],
             'type': 'union'},
'country': u'Eastern Africa',
'uuid': u'e3daf92a-88d2-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'098771a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Angola'),
                            (u'0cb47d54-7d7e-11de-9ae2-0019e336be3a',
                             u'Cameroon'),
                            (u'0cd759a0-7d7e-11de-9ae2-0019e336be3a',
                             u'Central African Republic'),
                            (u'0cbbba9c-7d7e-11de-9ae2-0019e336be3a',
                             u'Chad'),
                            (u'0c193b28-7d7e-11de-9ae2-0019e336be3a',
                             u'Congo'),
                            (u'0c29d73a-7d7e-11de-9ae2-0019e336be3a',
                             u'Congo, Democratic Republic of the'),
                            (u'0d245584-7d7e-11de-9ae2-0019e336be3a',
                             u'Equatorial Guinea'),
                            (u'0d8399c2-7d7e-11de-9ae2-0019e336be3a',
                             u'Gabon'),
                            (u'133bfb7a-7d7e-11de-9ae2-0019e336be3a',
                             u'Sao Tome and Principe')],
             'type': 'union'},
'country': u'Middle Africa',
'uuid': u'e60b420e-88d2-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'12bee8d8-7d7e-11de-9ae2-0019e336be3a',
                             u'Botswana'),
                            (u'12ba54da-7d7e-11de-9ae2-0019e336be3a',
                             u'Lesotho'),
                            (u'145e04ee-7d7e-11de-9ae2-0019e336be3a',
                             u'Namibia'),
                            (u'12b21766-7d7e-11de-9ae2-0019e336be3a',
                             u'South Africa'),
                            (u'146af956-7d7e-11de-9ae2-0019e336be3a',
                             u'Swaziland')],
             'type': 'union'},
'country': u'Southern Africa',
'uuid': u'e6d3af00-88d2-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0a13f5c0-7d7e-11de-9ae2-0019e336be3a',
                             u'Benin'),
                            (u'1420c7f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Burkina Faso'),
                            (u'0cec2628-7d7e-11de-9ae2-0019e336be3a',
                             u'Cape Verde'),
                            (u'0ec6dff6-7d7e-11de-9ae2-0019e336be3a',
                             u"Cote d'Ivoire"),
                            (u'0d7e9abc-7d7e-11de-9ae2-0019e336be3a',
                             u'Gambia'),
                            (u'0d95a34c-7d7e-11de-9ae2-0019e336be3a',
                             u'Ghana'),
                            (u'0e34b6f8-7d7e-11de-9ae2-0019e336be3a',
                             u'Guinea'),
                            (u'11738740-7d7e-11de-9ae2-0019e336be3a',
                             u'Guinea-Bissau'),
                            (u'0f4c70f8-7d7e-11de-9ae2-0019e336be3a',
                             u'Liberia'),
                            (u'0f7d8030-7d7e-11de-9ae2-0019e336be3a',
                             u'Mali'),
                            (u'0f8e6c2e-7d7e-11de-9ae2-0019e336be3a',
                             u'Mauritania'),
                            (u'0fe7b522-7d7e-11de-9ae2-0019e336be3a',
                             u'Niger'),
                            (u'10d6bc3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Nigeria'),
                            (u'1510fb80-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Helena'),
                            (u'12c6a37a-7d7e-11de-9ae2-0019e336be3a',
                             u'Senegal'),
                            (u'12d57c60-7d7e-11de-9ae2-0019e336be3a',
                             u'Sierra Leone'),
                            (u'1337d22a-7d7e-11de-9ae2-0019e336be3a',
                             u'Togo')],
             'type': 'union'},
'country': u'Western Africa',
'uuid': u'e89dc6f4-88d2-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'095ec4f2-7d7e-11de-9ae2-0019e336be3a',
                             u'Algeria'),
                            (u'0d168940-7d7e-11de-9ae2-0019e336be3a',
                             u'Egypt'),
                            (u'0f59bb46-7d7e-11de-9ae2-0019e336be3a',
                             u'Libyan Arab Jamahiriya'),
                            (u'0f848e98-7d7e-11de-9ae2-0019e336be3a',
                             u'Morocco'),
                            (u'12f773b0-7d7e-11de-9ae2-0019e336be3a',
                             u'Sudan'),
                            (u'133fc02a-7d7e-11de-9ae2-0019e336be3a',
                             u'Tunisia'),
                            (u'151bdf00-7d7e-11de-9ae2-0019e336be3a',
                             u'Western Sahara')],
             'type': 'union'},
'country': u'Northern Africa',
'uuid': u'e675a82e-88d2-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'09f36814-7d7e-11de-9ae2-0019e336be3a',
                             u'Belize'),
                            (u'0cd04f34-7d7e-11de-9ae2-0019e336be3a',
                             u'Costa Rica'),
                            (u'0d349e44-7d7e-11de-9ae2-0019e336be3a',
                             u'El Salvador'),
                            (u'0e2fbd60-7d7e-11de-9ae2-0019e336be3a',
                             u'Guatemala'),
                            (u'0e4809f6-7d7e-11de-9ae2-0019e336be3a',
                             u'Honduras'),
                            (u'0fa9a53e-7d7e-11de-9ae2-0019e336be3a',
                             u'Mexico'),
                            (u'111cdba2-7d7e-11de-9ae2-0019e336be3a',
                             u'Nicaragua'),
                            (u'115546c2-7d7e-11de-9ae2-0019e336be3a',
                             u'Panama')],
             'type': 'union'},
'country': u'Central America',
'uuid': u'fc467bec-d8f0-11de-b1d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0fefde28-7d7e-11de-9ae2-0019e336be3a',
                             u'Anguilla'),
                            (u'09581fbc-7d7e-11de-9ae2-0019e336be3a',
                             u'Antigua and Barbuda'),
                            (u'0fec983a-7d7e-11de-9ae2-0019e336be3a',
                             u'Aruba'),
                            (u'09da334e-7d7e-11de-9ae2-0019e336be3a',
                             u'Bahamas'),
                            (u'09d2df90-7d7e-11de-9ae2-0019e336be3a',
                             u'Barbados'),
                            (u'0cb02330-7d7e-11de-9ae2-0019e336be3a',
                             u'Cayman Islands'),
                            (u'0ce31d3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Cuba'),
                            (u'0d04edb6-7d7e-11de-9ae2-0019e336be3a',
                             u'Dominica'),
                            (u'0d083d04-7d7e-11de-9ae2-0019e336be3a',
                             u'Dominican Republic'),
                            (u'0d9a9384-7d7e-11de-9ae2-0019e336be3a',
                             u'Grenada'),
                            (u'14f2285e-7d7e-11de-9ae2-0019e336be3a',
                             u'Guadeloupe'),
                            (u'0e422e82-7d7e-11de-9ae2-0019e336be3a',
                             u'Haiti'),
                            (u'0eed3c64-7d7e-11de-9ae2-0019e336be3a',
                             u'Jamaica'),
                            (u'0f671a66-7d7e-11de-9ae2-0019e336be3a',
                             u'Martinique'),
                            (u'0f759550-7d7e-11de-9ae2-0019e336be3a',
                             u'Montserrat'),
                            (u'14f6044c-7d7e-11de-9ae2-0019e336be3a',
                             u'Netherlands Antilles'),
                            (u'11a7c1a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Puerto Rico'),
                            (u'153e85be-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Barthelemy'),
                            (u'12a2ee3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Kitts and Nevis'),
                            (u'12f2d954-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Lucia'),
                            (u'153b614a-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Martin'),
                            (u'1436d536-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Vincent and the Grenadines'),
                            (u'1317a572-7d7e-11de-9ae2-0019e336be3a',
                             u'Trinidad and Tobago'),
                            (u'15177c76-7d7e-11de-9ae2-0019e336be3a',
                             u'Turks and Caicos Islands'),
                            (u'14480004-7d7e-11de-9ae2-0019e336be3a',
                             u'Virgin Islands, British'),
                            (u'14599396-7d7e-11de-9ae2-0019e336be3a',
                             u'Virgin Islands, U.S.')],
             'type': 'union'},
'country': u'Caribbean',
'uuid': u'5e8a8a1e-20b3-11df-9cb2-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'09d5d736-7d7e-11de-9ae2-0019e336be3a',
                             u'Bermuda'),
                            (u'0b2a8a96-7d7e-11de-9ae2-0019e336be3a',
                             u'Canada'),
                            (u'0dc048d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Greenland'),
                            (u'150dbd3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Saint Pierre and Miquelon'),
                            (u'13d387f6-7d7e-11de-9ae2-0019e336be3a',
                             u'United States')],
             'type': 'union'},
'country': u'Northern America',
'uuid': u'0fecb5e8-7e2a-11de-9820-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'09951f84-7d7e-11de-9ae2-0019e336be3a',
                             u'Argentina'),
                            (u'09fd4f82-7d7e-11de-9ae2-0019e336be3a',
                             u'Bolivia, Plurinational State of'),
                            (u'0a2c8c66-7d7e-11de-9ae2-0019e336be3a',
                             u'Brazil'),
                            (u'0c852cde-7d7e-11de-9ae2-0019e336be3a',
                             u'Chile'),
                            (u'0cc6c45a-7d7e-11de-9ae2-0019e336be3a',
                             u'Colombia'),
                            (u'0d0e72a0-7d7e-11de-9ae2-0019e336be3a',
                             u'Ecuador'),
                            (u'0d627bf2-7d7e-11de-9ae2-0019e336be3a',
                             u'Falkland Islands (Malvinas)'),
                            (u'0d4ac2be-7d7e-11de-9ae2-0019e336be3a',
                             u'French Guiana'),
                            (u'0e3b3d98-7d7e-11de-9ae2-0019e336be3a',
                             u'Guyana'),
                            (u'11311298-7d7e-11de-9ae2-0019e336be3a',
                             u'Paraguay'),
                            (u'11387d6c-7d7e-11de-9ae2-0019e336be3a',
                             u'Peru'),
                            (u'1117f7f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Suriname'),
                            (u'14266b60-7d7e-11de-9ae2-0019e336be3a',
                             u'Uruguay'),
                            (u'143d4e2a-7d7e-11de-9ae2-0019e336be3a',
                             u'Venezuela')],
             'type': 'union'},
'country': u'South America',
'uuid': u'1ae80e7c-e5e3-11de-a739-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0f1fdb74-7d7e-11de-9ae2-0019e336be3a',
                             u'Kazakhstan'),
                            (u'0efacce4-7d7e-11de-9ae2-0019e336be3a',
                             u'Kyrgyzstan'),
                            (u'13293cec-7d7e-11de-9ae2-0019e336be3a',
                             u'Tajikistan'),
                            (u'1356be2e-7d7e-11de-9ae2-0019e336be3a',
                             u'Turkmenistan'),
                            (u'142f54c8-7d7e-11de-9ae2-0019e336be3a',
                             u'Uzbekistan')],
             'type': 'union'},
'country': u'Central Asia',
'uuid': u'23ccc3fe-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0c40fa1e-7d7e-11de-9ae2-0019e336be3a',
                             u'China'),
                            (u'0ff7be54-7d7e-11de-9ae2-0019e336be3a',
                             u'Hong Kong'),
                            (u'0ed905c8-7d7e-11de-9ae2-0019e336be3a',
                             u'Japan'),
                            (u'0f0215a8-7d7e-11de-9ae2-0019e336be3a',
                             u"Korea, Democratic People's Republic of"),
                            (u'0f0f980e-7d7e-11de-9ae2-0019e336be3a',
                             u'Korea, Republic of'),
                            (u'10105c52-7d7e-11de-9ae2-0019e336be3a',
                             u'Macau'),
                            (u'0f6c1a98-7d7e-11de-9ae2-0019e336be3a',
                             u'Mongolia'),
                            (u'154d2934-7d7e-11de-9ae2-0019e336be3a',
                             u'Taiwan, Province of China')],
             'type': 'union'},
'country': u'Eastern Asia',
'uuid': u'2b57aeea-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'2969cad2-2132-11df-896e-0019e336be3a', 
                             u'Disputed Kashmir'),
                            (u'0c608726-7d7e-11de-9ae2-0019e336be3a',
                             u'Afghanistan'),
                            (u'09e8ed3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Bangladesh'),
                            (u'0c67c0cc-7d7e-11de-9ae2-0019e336be3a',
                             u'Bhutan'),
                            (u'0e6a7860-7d7e-11de-9ae2-0019e336be3a',
                             u'India'),
                            (u'0ea9e766-7d7e-11de-9ae2-0019e336be3a',
                             u'Iran (Islamic Republic of)'),
                            (u'0f9f2f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Maldives'),
                            (u'110f1ea4-7d7e-11de-9ae2-0019e336be3a',
                             u'Nepal'),
                            (u'11430eee-7d7e-11de-9ae2-0019e336be3a',
                             u'Pakistan'),
                            (u'0c13823c-7d7e-11de-9ae2-0019e336be3a',
                             u'Sri Lanka')],
             'type': 'union'},
'country': u'Southern Asia',
'uuid': u'30e68c9c-7e2a-11de-9820-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0a4bff9c-7d7e-11de-9ae2-0019e336be3a',
                             u'Brunei Darussalam'),
                            (u'0c0d5768-7d7e-11de-9ae2-0019e336be3a',
                             u'Cambodia'),
                            (u'14ba15f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Indonesia'),
                            (u'0f2f07ac-7d7e-11de-9ae2-0019e336be3a',
                             u"Lao People's Democratic Republic"),
                            (u'0fbd80a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Malaysia'),
                            (u'0a06dd7c-7d7e-11de-9ae2-0019e336be3a',
                             u'Myanmar'),
                            (u'119679bc-7d7e-11de-9ae2-0019e336be3a',
                             u'Philippines'),
                            (u'12dcac1a-7d7e-11de-9ae2-0019e336be3a',
                             u'Singapore'),
                            (u'131dd2ee-7d7e-11de-9ae2-0019e336be3a',
                             u'Thailand'),
                            (u'14fec0f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Timor-Leste'),
                            (u'144e6f5c-7d7e-11de-9ae2-0019e336be3a',
                             u'Viet Nam')],
             'type': 'union'},
'country': u'South-Eastern Asia',
'uuid': u'4aff9c9e-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'09818690-7d7e-11de-9ae2-0019e336be3a',
                             u'Armenia'),
                            (u'096781b4-7d7e-11de-9ae2-0019e336be3a',
                             u'Azerbaijan'),
                            (u'09cf6a0e-7d7e-11de-9ae2-0019e336be3a',
                             u'Bahrain'),
                            (u'0cf40280-7d7e-11de-9ae2-0019e336be3a',
                             u'Cyprus'),
                            (u'0d8feaa6-7d7e-11de-9ae2-0019e336be3a',
                             u'Georgia'),
                            (u'0ecd6952-7d7e-11de-9ae2-0019e336be3a',
                             u'Iraq'),
                            (u'0eb3bcbe-7d7e-11de-9ae2-0019e336be3a',
                             u'Israel'),
                            (u'0ef0fe6c-7d7e-11de-9ae2-0019e336be3a',
                             u'Jordan'),
                            (u'0f16e870-7d7e-11de-9ae2-0019e336be3a',
                             u'Kuwait'),
                            (u'0f35d820-7d7e-11de-9ae2-0019e336be3a',
                             u'Lebanon'),
                            (u'0f980b80-7d7e-11de-9ae2-0019e336be3a',
                             u'Oman'),
                            (u'1019325a-7d7e-11de-9ae2-0019e336be3a',
                             u'Palestinian Territory, Occupied'),
                            (u'117936fe-7d7e-11de-9ae2-0019e336be3a',
                             u'Qatar'),
                            (u'129c6a88-7d7e-11de-9ae2-0019e336be3a',
                             u'Saudi Arabia'),
                            (u'130d4f28-7d7e-11de-9ae2-0019e336be3a',
                             u'Syrian Arab Republic'),
                            (u'1347b0a0-7d7e-11de-9ae2-0019e336be3a',
                             u'Turkey'),
                            (u'14f9e5d0-7d7e-11de-9ae2-0019e336be3a',
                             u'United Arab Emirates'),
                            (u'146f1702-7d7e-11de-9ae2-0019e336be3a',
                             u'Yemen')],
             'type': 'union'},
'country': u'Western Asia',
'uuid': u'4ed30b08-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'09b1a988-7d7e-11de-9ae2-0019e336be3a',
                             u'Australia'),
                            (u'11258d1a-7d7e-11de-9ae2-0019e336be3a',
                             u'New Zealand'),
                            (u'10271ce4-7d7e-11de-9ae2-0019e336be3a',
                             u'Norfolk Island')],
             'type': 'union'},
'country': u'Australia and New Zealand',
'uuid': u'fb4bde60-e62b-11de-ba56-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0d5bcf64-7d7e-11de-9ae2-0019e336be3a',
                             u'Fiji'),
                            (u'0fdb5bec-7d7e-11de-9ae2-0019e336be3a',
                             u'New Caledonia'),
                            (u'11663ae0-7d7e-11de-9ae2-0019e336be3a',
                             u'Papua New Guinea'),
                            (u'0a1ab78e-7d7e-11de-9ae2-0019e336be3a',
                             u'Solomon Islands'),
                            (u'10cf3776-7d7e-11de-9ae2-0019e336be3a',
                             u'Vanuatu')],
             'type': 'union'},
'country': u'Melanesia',
'uuid': u'13fd916a-e62c-11de-ba56-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0e1a52e0-7d7e-11de-9ae2-0019e336be3a',
                             u'Guam'),
                            (u'0f0882c6-7d7e-11de-9ae2-0019e336be3a',
                             u'Kiribati'),
                            (u'15099fa2-7d7e-11de-9ae2-0019e336be3a',
                             u'Marshall Islands'),
                            (u'0d684cbc-7d7e-11de-9ae2-0019e336be3a',
                             u'Micronesia, Federated States of'),
                            (u'11148498-7d7e-11de-9ae2-0019e336be3a',
                             u'Nauru'),
                            (u'0ffb63d8-7d7e-11de-9ae2-0019e336be3a',
                             u'Northern Mariana Islands'),
                            (u'1505b46e-7d7e-11de-9ae2-0019e336be3a',
                             u'Palau')],
             'type': 'union'},
'country': u'Micronesia',
'uuid': u'26bf514e-e62c-11de-ba56-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'098df75e-7d7e-11de-9ae2-0019e336be3a',
                             u'American Samoa'),
                            (u'0cf01346-7d7e-11de-9ae2-0019e336be3a',
                             u'Cook Islands'),
                            (u'0d6d36be-7d7e-11de-9ae2-0019e336be3a',
                             u'French Polynesia'),
                            (u'0fe1621c-7d7e-11de-9ae2-0019e336be3a',
                             u'Niue'),
                            (u'150266d8-7d7e-11de-9ae2-0019e336be3a',
                             u'Pitcairn'),
                            (u'14679ce8-7d7e-11de-9ae2-0019e336be3a',
                             u'Samoa'),
                            (u'132fcda0-7d7e-11de-9ae2-0019e336be3a',
                             u'Tokelau'),
                            (u'13335286-7d7e-11de-9ae2-0019e336be3a',
                             u'Tonga'),
                            (u'1351b0f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Tuvalu'),
                            (u'14644bba-7d7e-11de-9ae2-0019e336be3a',
                             u'Wallis and Futuna')],
             'type': 'union'},
'country': u'Polynesia',
'uuid': u'4d22983c-e62c-11de-ba56-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0d28a62a-7d7e-11de-9ae2-0019e336be3a',
                             u'Estonia'),
                            (u'0f3a36f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Latvia'),
                            (u'0f46d4ea-7d7e-11de-9ae2-0019e336be3a',
                             u'Lithuania')],
             'type': 'union'},
'country': u'Baltic System Operator',
'uuid': u'd4c8443a-d821-11de-b50d-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Czech Republic'),
                            (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a',
                             u'Hungary'),
                            (u'114ebb04-7d7e-11de-9ae2-0019e336be3a',
                             u'Poland'),
                            (u'0f515f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovakia')],
             'type': 'union'},
'country': u'Central European Power Association',
'uuid': u'fd95ae8c-7e2d-11de-9820-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0f405034-7d7e-11de-9ae2-0019e336be3a',
                             u'Belarus'),
                            (u'0a46f524-7d7e-11de-9ae2-0019e336be3a',
                             u'Bulgaria'),
                            (u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Czech Republic'),
                            (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a',
                             u'Hungary'),
                            (u'1188faee-7d7e-11de-9ae2-0019e336be3a',
                             u'Moldova, Republic of'),
                            (u'114ebb04-7d7e-11de-9ae2-0019e336be3a',
                             u'Poland'),
                            (u'11813638-7d7e-11de-9ae2-0019e336be3a',
                             u'Romania'),
                            (u'12143bfe-7d7e-11de-9ae2-0019e336be3a',
                             u'Russian Federation'),
                            (u'0f515f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovakia'),
                            (u'1387ef8a-7d7e-11de-9ae2-0019e336be3a',
                             u'Ukraine')],
             'type': 'union'},
'country': u'Commonwealth of Independent States',
'uuid': u'14a80a4c-7e2a-11de-9820-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0f405034-7d7e-11de-9ae2-0019e336be3a',
                             u'Belarus'),
                            (u'0a46f524-7d7e-11de-9ae2-0019e336be3a',
                             u'Bulgaria'),
                            (u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Czech Republic'),
                            (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a',
                             u'Hungary'),
                            (u'1188faee-7d7e-11de-9ae2-0019e336be3a',
                             u'Moldova, Republic of'),
                            (u'114ebb04-7d7e-11de-9ae2-0019e336be3a',
                             u'Poland'),
                            (u'11813638-7d7e-11de-9ae2-0019e336be3a',
                             u'Romania'),
                            (u'12143bfe-7d7e-11de-9ae2-0019e336be3a',
                             u'Russian Federation'),
                            (u'0f515f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovakia'),
                            (u'1387ef8a-7d7e-11de-9ae2-0019e336be3a',
                             u'Ukraine')],
             'type': 'union'},
'country': u'Eastern Europe',
'uuid': u'50ec320c-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0cf950f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Denmark'),
                            (u'0d28a62a-7d7e-11de-9ae2-0019e336be3a',
                             u'Estonia'),
                            (u'0fff8e5e-7d7e-11de-9ae2-0019e336be3a',
                             u'Faroe Islands'),
                            (u'0d512a50-7d7e-11de-9ae2-0019e336be3a',
                             u'Finland'),
                            (u'1541988a-7d7e-11de-9ae2-0019e336be3a',
                             u'Guernsey'),
                            (u'0e5d5856-7d7e-11de-9ae2-0019e336be3a',
                             u'Iceland'),
                            (u'0d1de104-7d7e-11de-9ae2-0019e336be3a',
                             u'Ireland'),
                            (u'1009d666-7d7e-11de-9ae2-0019e336be3a',
                             u'Isle of Man'),
                            (u'1544d680-7d7e-11de-9ae2-0019e336be3a',
                             u'Jersey'),
                            (u'0f3a36f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Latvia'),
                            (u'0f46d4ea-7d7e-11de-9ae2-0019e336be3a',
                             u'Lithuania'),
                            (u'10f1ec30-7d7e-11de-9ae2-0019e336be3a',
                             u'Norway'),
                            (u'152d7e40-7d7e-11de-9ae2-0019e336be3a',
                             u'Svalbard and Jan Mayen'),
                            (u'1301c428-7d7e-11de-9ae2-0019e336be3a',
                             u'Sweden'),
                            (u'13725fee-7d7e-11de-9ae2-0019e336be3a',
                             u'United Kingdom'),
                            (u'1023d322-7d7e-11de-9ae2-0019e336be3a',
                             u'\xc5land Islands')],
             'type': 'union'},
'country': u'Northern Europe',
'uuid': u'548bd19c-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'097c2556-7d7e-11de-9ae2-0019e336be3a',
                             u'Albania'),
                            (u'10033c48-7d7e-11de-9ae2-0019e336be3a',
                             u'Andorra'),
                            (u'09f7dc00-7d7e-11de-9ae2-0019e336be3a',
                             u'Bosnia and Herzegovina'),
                            (u'0e4ef37e-7d7e-11de-9ae2-0019e336be3a',
                             u'Croatia'),
                            (u'10061efe-7d7e-11de-9ae2-0019e336be3a',
                             u'Gibraltar'),
                            (u'0e22b962-7d7e-11de-9ae2-0019e336be3a',
                             u'Greece'),
                            (u'15265aa2-7d7e-11de-9ae2-0019e336be3a',
                             u'Holy See (Vatican City State)'),
                            (u'0ebb28b4-7d7e-11de-9ae2-0019e336be3a',
                             u'Italy'),
                            (u'adb98942-1fc2-11df-8b04-0019e336be3a',
                             u'Kosovo'),
                            (u'0f78e944-7d7e-11de-9ae2-0019e336be3a',
                             u'Macedonia, the Former Yugoslav Republic of'),
                            (u'0f9402ce-7d7e-11de-9ae2-0019e336be3a',
                             u'Malta'),
                            (u'101cf458-7d7e-11de-9ae2-0019e336be3a',
                             u'Montenegro'),
                            (u'115c647a-7d7e-11de-9ae2-0019e336be3a',
                             u'Portugal'),
                            (u'15146d88-7d7e-11de-9ae2-0019e336be3a',
                             u'San Marino'),
                            (u'1520c2a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Serbia'),
                            (u'12d0bd4c-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovenia'),
                            (u'12ea642c-7d7e-11de-9ae2-0019e336be3a',
                             u'Spain')],
             'type': 'union'},
'country': u'Southern Europe',
'uuid': u'57c8c52c-88d5-11de-99d3-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0d3f4416-7d7e-11de-9ae2-0019e336be3a',
                             u'Austria'),
                            (u'0ff33cbc-7d7e-11de-9ae2-0019e336be3a',
                             u'Belgium'),
                            (u'0d751636-7d7e-11de-9ae2-0019e336be3a',
                             u'France'),
                            (u'0e0e1020-7d7e-11de-9ae2-0019e336be3a',
                             u'Germany'),
                            (u'0f55e480-7d7e-11de-9ae2-0019e336be3a',
                             u'Liechtenstein'),
                            (u'100cd4b0-7d7e-11de-9ae2-0019e336be3a',
                             u'Luxembourg'),
                            (u'1013310c-7d7e-11de-9ae2-0019e336be3a',
                             u'Monaco'),
                            (u'10df2fe6-7d7e-11de-9ae2-0019e336be3a',
                             u'Netherlands'),
                            (u'131278d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Switzerland')],
             'type': 'union'},
'country': u'Western Europe',
'uuid': u'DE74489A-E3BF-4b3a-8463-B7B9EBA8A8FB'},
{'components': {'buffer': 0.0001,
             'components': [(u'10033c48-7d7e-11de-9ae2-0019e336be3a',
                             u'Andorra'),
                            (u'0d3f4416-7d7e-11de-9ae2-0019e336be3a',
                             u'Austria'),
                            (u'0ff33cbc-7d7e-11de-9ae2-0019e336be3a',
                             u'Belgium'),
                            (u'09f7dc00-7d7e-11de-9ae2-0019e336be3a',
                             u'Bosnia and Herzegovina'),
                            (u'0a46f524-7d7e-11de-9ae2-0019e336be3a',
                             u'Bulgaria'),
                            (u'0e4ef37e-7d7e-11de-9ae2-0019e336be3a',
                             u'Croatia'),
                            (u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Czech Republic'),
                            (u'0cf950f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Denmark'),
                            (u'0d28a62a-7d7e-11de-9ae2-0019e336be3a',
                             u'Estonia'),
                            (u'0d512a50-7d7e-11de-9ae2-0019e336be3a',
                             u'Finland'),
                            (u'0d751636-7d7e-11de-9ae2-0019e336be3a',
                             u'France'),
                            (u'0e0e1020-7d7e-11de-9ae2-0019e336be3a',
                             u'Germany'),
                            (u'0e22b962-7d7e-11de-9ae2-0019e336be3a',
                             u'Greece'),
                            (u'15265aa2-7d7e-11de-9ae2-0019e336be3a',
                             u'Holy See (Vatican City State)'),
                            (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a',
                             u'Hungary'),
                            (u'0d1de104-7d7e-11de-9ae2-0019e336be3a',
                             u'Ireland'),
                            (u'0ebb28b4-7d7e-11de-9ae2-0019e336be3a',
                             u'Italy'),
                            (u'adb98942-1fc2-11df-8b04-0019e336be3a',
                             u'Kosovo'),
                            (u'0f3a36f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Latvia'),
                            (u'0f55e480-7d7e-11de-9ae2-0019e336be3a',
                             u'Liechtenstein'),
                            (u'0f46d4ea-7d7e-11de-9ae2-0019e336be3a',
                             u'Lithuania'),
                            (u'100cd4b0-7d7e-11de-9ae2-0019e336be3a',
                             u'Luxembourg'),
                            (u'0f78e944-7d7e-11de-9ae2-0019e336be3a',
                             u'Macedonia, the Former Yugoslav Republic of'),
                            (u'1013310c-7d7e-11de-9ae2-0019e336be3a',
                             u'Monaco'),
                            (u'101cf458-7d7e-11de-9ae2-0019e336be3a',
                             u'Montenegro'),
                            (u'10df2fe6-7d7e-11de-9ae2-0019e336be3a',
                             u'Netherlands'),
                            (u'10f1ec30-7d7e-11de-9ae2-0019e336be3a',
                             u'Norway'),
                            (u'114ebb04-7d7e-11de-9ae2-0019e336be3a',
                             u'Poland'),
                            (u'115c647a-7d7e-11de-9ae2-0019e336be3a',
                             u'Portugal'),
                            (u'11813638-7d7e-11de-9ae2-0019e336be3a',
                             u'Romania'),
                            (u'15146d88-7d7e-11de-9ae2-0019e336be3a',
                             u'San Marino'),
                            (u'1520c2a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Serbia'),
                            (u'0f515f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovakia'),
                            (u'12d0bd4c-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovenia'),
                            (u'12ea642c-7d7e-11de-9ae2-0019e336be3a',
                             u'Spain'),
                            (u'1301c428-7d7e-11de-9ae2-0019e336be3a',
                             u'Sweden'),
                            (u'131278d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Switzerland'),
                            (u'13725fee-7d7e-11de-9ae2-0019e336be3a',
                             u'United Kingdom')],
             'type': 'union'},
'country': u'European Network of Transmission Systems Operators for Electricity',
'uuid': u'f87aa98c-d820-11de-a736-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0ea9e766-7d7e-11de-9ae2-0019e336be3a',
                             u'Iran (Islamic Republic of)'),
                            (u'0ecd6952-7d7e-11de-9ae2-0019e336be3a',
                             u'Iraq'),
                            (u'0f16e870-7d7e-11de-9ae2-0019e336be3a',
                             u'Kuwait'),
                            (u'117936fe-7d7e-11de-9ae2-0019e336be3a',
                             u'Qatar'),
                            (u'129c6a88-7d7e-11de-9ae2-0019e336be3a',
                             u'Saudi Arabia'),
                            (u'14f9e5d0-7d7e-11de-9ae2-0019e336be3a',
                             u'United Arab Emirates')],
             'type': 'union'},
'country': u'Middle East',
'uuid': u'fd6f25d2-7e2d-11de-9820-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'0b2a8a96-7d7e-11de-9ae2-0019e336be3a',
                             u'Canada'),
                            (u'0fa9a53e-7d7e-11de-9ae2-0019e336be3a',
                             u'Mexico'),
                            (u'13d387f6-7d7e-11de-9ae2-0019e336be3a',
                             u'United States')],
             'type': 'union'},
'country': u'North American Free Trade Agreement',
'uuid': u'047116e2-d932-11de-9627-0019e336be3a'},
{'components': {'buffer': 0.0001,
             'components': [(u'adb98942-1fc2-11df-8b04-0019e336be3a',
                             u'Kosovo'),
                            (u'101cf458-7d7e-11de-9ae2-0019e336be3a',
                             u'Montenegro'),
                            (u'1520c2a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Serbia')],
             'type': 'union'},
'country': u'Serbia and Montenegro',
'uuid': u'4EB91D59-44F6-4ec6-9F21-0C48BCF3BECF'},
{'components': {'buffer': 0.0001,
             'components': [(u'b3eaa448-2122-11df-8c13-0019e336be3a',
                             u'UCTE Denmark'),
                            (u'10033c48-7d7e-11de-9ae2-0019e336be3a',
                             u'Andorra'),
                            (u'0d3f4416-7d7e-11de-9ae2-0019e336be3a',
                             u'Austria'),
                            (u'0ff33cbc-7d7e-11de-9ae2-0019e336be3a',
                             u'Belgium'),
                            (u'09f7dc00-7d7e-11de-9ae2-0019e336be3a',
                             u'Bosnia and Herzegovina'),
                            (u'0a46f524-7d7e-11de-9ae2-0019e336be3a',
                             u'Bulgaria'),
                            (u'0e4ef37e-7d7e-11de-9ae2-0019e336be3a',
                             u'Croatia'),
                            (u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Czech Republic'),
                            (u'0d751636-7d7e-11de-9ae2-0019e336be3a',
                             u'France'),
                            (u'0e0e1020-7d7e-11de-9ae2-0019e336be3a',
                             u'Germany'),
                            (u'0e22b962-7d7e-11de-9ae2-0019e336be3a',
                             u'Greece'),
                            (u'15265aa2-7d7e-11de-9ae2-0019e336be3a',
                             u'Holy See (Vatican City State)'),
                            (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a',
                             u'Hungary'),
                            (u'0ebb28b4-7d7e-11de-9ae2-0019e336be3a',
                             u'Italy'),
                            (u'adb98942-1fc2-11df-8b04-0019e336be3a',
                             u'Kosovo'),
                            (u'0f55e480-7d7e-11de-9ae2-0019e336be3a',
                             u'Liechtenstein'),
                            (u'100cd4b0-7d7e-11de-9ae2-0019e336be3a',
                             u'Luxembourg'),
                            (u'0f78e944-7d7e-11de-9ae2-0019e336be3a',
                             u'Macedonia, the Former Yugoslav Republic of'),
                            (u'1013310c-7d7e-11de-9ae2-0019e336be3a',
                             u'Monaco'),
                            (u'101cf458-7d7e-11de-9ae2-0019e336be3a',
                             u'Montenegro'),
                            (u'10df2fe6-7d7e-11de-9ae2-0019e336be3a',
                             u'Netherlands'),
                            (u'114ebb04-7d7e-11de-9ae2-0019e336be3a',
                             u'Poland'),
                            (u'115c647a-7d7e-11de-9ae2-0019e336be3a',
                             u'Portugal'),
                            (u'11813638-7d7e-11de-9ae2-0019e336be3a',
                             u'Romania'),
                            (u'15146d88-7d7e-11de-9ae2-0019e336be3a',
                             u'San Marino'),
                            (u'1520c2a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Serbia'),
                            (u'0f515f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovakia'),
                            (u'12d0bd4c-7d7e-11de-9ae2-0019e336be3a',
                             u'Slovenia'),
                            (u'12ea642c-7d7e-11de-9ae2-0019e336be3a',
                             u'Spain'),
                            (u'131278d6-7d7e-11de-9ae2-0019e336be3a',
                             u'Switzerland')],
             'type': 'union'},
'country': u'Union for the Co-ordination of Transmission of Electricity',
'uuid': u'CE1503BE-7060-4959-8387-BC3EA3F4C885'},
{'uuid': u'454039ee-211e-11df-8c13-0019e336be3a',
'country': u'European Kazakhstan, Azerbaijan, Georgia, Turkey',
'components': ({
    'type': 'union',
    'buffer': False,
    'components': ((u'0f1fdb74-7d7e-11de-9ae2-0019e336be3a',
                     u'Kazakhstan'),
                   (u'096781b4-7d7e-11de-9ae2-0019e336be3a',
                     u'Azerbaijan'),
                   (u'0d8feaa6-7d7e-11de-9ae2-0019e336be3a',
                     u'Georgia'),
                   (u'1347b0a0-7d7e-11de-9ae2-0019e336be3a',
                     u'Turkey'))
    },
    {'type': 'intersection',
    'buffer': False,
    'components': (u'df6b1ebc-e0be-11de-823b-0019e336be3a',
        u'European sections of Kazakhstan, Azerbaijan, Georgia, and Turkey')}
)},
{'uuid': u'04147ac8-2120-11df-8c13-0019e336be3a',
'country': u'Asian Kazakhstan, Azerbaijan, Georgia, Turkey',
'components': ({
    'type': 'union',
    'buffer': False,
    'components': ((u'0f1fdb74-7d7e-11de-9ae2-0019e336be3a',
                     u'Kazakhstan'),
                   (u'096781b4-7d7e-11de-9ae2-0019e336be3a',
                     u'Azerbaijan'),
                   (u'0d8feaa6-7d7e-11de-9ae2-0019e336be3a',
                     u'Georgia'),
                   (u'1347b0a0-7d7e-11de-9ae2-0019e336be3a',
                     u'Turkey'))
    },
    {'type': 'difference',
    'buffer': False,
    'components': (u'df6b1ebc-e0be-11de-823b-0019e336be3a',
        u'European sections of Kazakhstan, Azerbaijan, Georgia, and Turkey')}
)},
{'uuid': u'f030472a-e0b1-11de-882d-0019e336be3a',
'country': u'European Russia',
'components': ({
    'type': 'simple',
    'buffer': False,
    'components': (u'12143bfe-7d7e-11de-9ae2-0019e336be3a',
                 u'Russian Federation')
    },
    {'type': 'difference',
    'buffer': False,
    'components':(u'e2b01872-075b-40d4-8fc8-d3d0237c5127', u'Asian Europe Cutout')}
)},
{'uuid': u'1da06b40-e0b2-11de-882d-0019e336be3a',
'country': 'Asian Russia',
'components': ({
    'type': 'simple',
    'buffer': False,
    'components': (u'12143bfe-7d7e-11de-9ae2-0019e336be3a',
                 u'Russian Federation')
    },
    {'type': 'intersection',
    'buffer': False,
    'components':(u'e2b01872-075b-40d4-8fc8-d3d0237c5127', u'Asian Europe Cutout')}
)},
{'uuid': u'caadf7fc-2122-11df-8c13-0019e336be3a',
'country': u'NCPA Denmark',
'components': ({
    'type': 'simple',
    'buffer': False,
    'components': (u'0cf950f0-7d7e-11de-9ae2-0019e336be3a', u'Denmark')
    },
    {'type': 'intersection',
    'buffer': False,
    'components': (u'8694f3ae-2122-11df-8c13-0019e336be3a', u'NCPA Denmark cutout')
    }),
},
{'uuid': u'b3eaa448-2122-11df-8c13-0019e336be3a',
'country': u'UCTE Denmark',
'components': ({
    'type': 'simple',
    'buffer': False,
    'components': (u'0cf950f0-7d7e-11de-9ae2-0019e336be3a', u'Denmark')
    },
    {'type': 'difference',
    'buffer': False,
    'components': (u'8694f3ae-2122-11df-8c13-0019e336be3a', u'NCPA Denmark cutout')
    }),
},
# {'uuid': ,
# 'country': ,
# 'components': {
#     'type': 'union',
#     'buffer': 0.0001,
#     'components':
# }},
)

step_two = ({'components': {'buffer': False,
               'components': [(u'4ed30b08-88d5-11de-99d3-0019e336be3a',
                               u'Western Asia'),
                              (u'4aff9c9e-88d5-11de-99d3-0019e336be3a',
                               u'South-Eastern Asia'),
                              (u'23ccc3fe-88d5-11de-99d3-0019e336be3a',
                               u'Central Asia'),
                              (u'2b57aeea-88d5-11de-99d3-0019e336be3a',
                               u'Eastern Asia'),
                              (u'30e68c9c-7e2a-11de-9820-0019e336be3a',
                               u'Southern Asia')],
               'type': 'union'},
'country': u'Asia, UN Region',
'uuid': u'd509536a-7e28-11de-9820-0019e336be3a'},
{'uuid': u'19c7cdd2-e590-11de-9dfe-0019e336be3a',
'country': u'Asia',
'components': {'buffer': 0.0001,
              'type': 'union',
              'components': [(u'2969cad2-2132-11df-896e-0019e336be3a', 
                             u'Disputed Kashmir'),
                            (u'1da06b40-e0b2-11de-882d-0019e336be3a',
                             u'Asian Russia'),
                            (u'04147ac8-2120-11df-8c13-0019e336be3a',
                             u'Asian Kazakhstan, Azerbaijan, Georgia, Turkey'),
                            (u'0efacce4-7d7e-11de-9ae2-0019e336be3a',
                             u'Kyrgyzstan'),
                            (u'13293cec-7d7e-11de-9ae2-0019e336be3a',
                             u'Tajikistan'),
                            (u'1356be2e-7d7e-11de-9ae2-0019e336be3a',
                             u'Turkmenistan'),
                            (u'142f54c8-7d7e-11de-9ae2-0019e336be3a',
                             u'Uzbekistan'),
                            (u'0c40fa1e-7d7e-11de-9ae2-0019e336be3a',
                             u'China'),
                            (u'0ff7be54-7d7e-11de-9ae2-0019e336be3a',
                             u'Hong Kong'),
                            (u'0ed905c8-7d7e-11de-9ae2-0019e336be3a',
                             u'Japan'),
                            (u'0f0215a8-7d7e-11de-9ae2-0019e336be3a',
                             u"Korea, Democratic People's Republic of"),
                            (u'0f0f980e-7d7e-11de-9ae2-0019e336be3a',
                             u'Korea, Republic of'),
                            (u'10105c52-7d7e-11de-9ae2-0019e336be3a',
                             u'Macau'),
                            (u'0f6c1a98-7d7e-11de-9ae2-0019e336be3a',
                             u'Mongolia'),
                            (u'154d2934-7d7e-11de-9ae2-0019e336be3a',
                             u'Taiwan, Province of China'),
                            (u'0c608726-7d7e-11de-9ae2-0019e336be3a',
                             u'Afghanistan'),
                            (u'09e8ed3a-7d7e-11de-9ae2-0019e336be3a',
                             u'Bangladesh'),
                            (u'0c67c0cc-7d7e-11de-9ae2-0019e336be3a',
                             u'Bhutan'),
                            (u'0e6a7860-7d7e-11de-9ae2-0019e336be3a',
                             u'India'),
                            (u'0ea9e766-7d7e-11de-9ae2-0019e336be3a',
                             u'Iran (Islamic Republic of)'),
                            (u'0f9f2f00-7d7e-11de-9ae2-0019e336be3a',
                             u'Maldives'),
                            (u'110f1ea4-7d7e-11de-9ae2-0019e336be3a',
                             u'Nepal'),
                            (u'11430eee-7d7e-11de-9ae2-0019e336be3a',
                             u'Pakistan'),
                            (u'0c13823c-7d7e-11de-9ae2-0019e336be3a',
                             u'Sri Lanka'),
                            (u'0a4bff9c-7d7e-11de-9ae2-0019e336be3a',
                             u'Brunei Darussalam'),
                            (u'0c0d5768-7d7e-11de-9ae2-0019e336be3a',
                             u'Cambodia'),
                            (u'14ba15f4-7d7e-11de-9ae2-0019e336be3a',
                             u'Indonesia'),
                            (u'0f2f07ac-7d7e-11de-9ae2-0019e336be3a',
                             u"Lao People's Democratic Republic"),
                            (u'0fbd80a4-7d7e-11de-9ae2-0019e336be3a',
                             u'Malaysia'),
                            (u'0a06dd7c-7d7e-11de-9ae2-0019e336be3a',
                             u'Myanmar'),
                            (u'119679bc-7d7e-11de-9ae2-0019e336be3a',
                             u'Philippines'),
                            (u'12dcac1a-7d7e-11de-9ae2-0019e336be3a',
                             u'Singapore'),
                            (u'131dd2ee-7d7e-11de-9ae2-0019e336be3a',
                             u'Thailand'),
                            (u'14fec0f0-7d7e-11de-9ae2-0019e336be3a',
                             u'Timor-Leste'),
                            (u'144e6f5c-7d7e-11de-9ae2-0019e336be3a',
                             u'Viet Nam'),
                            (u'09818690-7d7e-11de-9ae2-0019e336be3a',
                             u'Armenia'),
                            (u'09cf6a0e-7d7e-11de-9ae2-0019e336be3a',
                             u'Bahrain'),
                            (u'0cf40280-7d7e-11de-9ae2-0019e336be3a',
                             u'Cyprus'),
                            (u'0ecd6952-7d7e-11de-9ae2-0019e336be3a',
                             u'Iraq'),
                            (u'0eb3bcbe-7d7e-11de-9ae2-0019e336be3a',
                             u'Israel'),
                            (u'0ef0fe6c-7d7e-11de-9ae2-0019e336be3a',
                             u'Jordan'),
                            (u'0f16e870-7d7e-11de-9ae2-0019e336be3a',
                             u'Kuwait'),
                            (u'0f35d820-7d7e-11de-9ae2-0019e336be3a',
                             u'Lebanon'),
                            (u'0f980b80-7d7e-11de-9ae2-0019e336be3a',
                             u'Oman'),
                            (u'1019325a-7d7e-11de-9ae2-0019e336be3a',
                             u'Palestinian Territory, Occupied'),
                            (u'117936fe-7d7e-11de-9ae2-0019e336be3a',
                             u'Qatar'),
                            (u'129c6a88-7d7e-11de-9ae2-0019e336be3a',
                             u'Saudi Arabia'),
                            (u'130d4f28-7d7e-11de-9ae2-0019e336be3a',
                             u'Syrian Arab Republic'),
                            (u'14f9e5d0-7d7e-11de-9ae2-0019e336be3a',
                             u'United Arab Emirates'),
                            (u'146f1702-7d7e-11de-9ae2-0019e336be3a',
                             u'Yemen')]}},
{'components': {'buffer': False,
               'components': ((u'50ec320c-88d5-11de-99d3-0019e336be3a',
                               u'Eastern Europe'),
                              (u'548bd19c-88d5-11de-99d3-0019e336be3a',
                               u'Northern Europe'),
                              (u'57c8c52c-88d5-11de-99d3-0019e336be3a',
                               u'Southern Europe'),
                              (u'DE74489A-E3BF-4b3a-8463-B7B9EBA8A8FB',
                               u'Western Europe')),
               'type': 'union'},
'country': u'Europe, UN Region',
'uuid': u'f2d812a2-e631-11de-ba56-0019e336be3a'},
{'components': {'buffer': False,
               'components': ((u'fb4bde60-e62b-11de-ba56-0019e336be3a',
                               u'Australia and New Zealand'),
                              (u'13fd916a-e62c-11de-ba56-0019e336be3a',
                               u'Melanesia'),
                              (u'26bf514e-e62c-11de-ba56-0019e336be3a',
                               u'Micronesia'),
                              (u'4d22983c-e62c-11de-ba56-0019e336be3a',
                               u'Polynesia')),
               'type': 'union'},
'country': u'Oceania',
'uuid': u'9232290c-e62b-11de-ba56-0019e336be3a'},
{'components': {'buffer': False,
               'components': ((u'fc467bec-d8f0-11de-b1d3-0019e336be3a',
                               u'Central America'),
                              (u'5e8a8a1e-20b3-11df-9cb2-0019e336be3a',
                               u'Caribbean'),
                              (u'0fecb5e8-7e2a-11de-9820-0019e336be3a',
                               u'Northern America'),
                              (u'1ae80e7c-e5e3-11de-a739-0019e336be3a',
                               u'South America')),
               'type': 'union'},
'country': u'Americas',
'uuid': u'2ea604e6-e5e8-11de-8102-0019e336be3a'},
{'components': {'buffer': False,
               'components': ((u'fc467bec-d8f0-11de-b1d3-0019e336be3a',
                               u'Central America'),
                              (u'5e8a8a1e-20b3-11df-9cb2-0019e336be3a',
                               u'Caribbean'),
                              (u'1ae80e7c-e5e3-11de-a739-0019e336be3a',
                               u'South America')),
               'type': 'union'},
'country': u'Latin America and the Caribbean',
'uuid': u'09db3260-7e2a-11de-9820-0019e336be3a'},
{'components': {'buffer': False,
               'components': ((u'e3daf92a-88d2-11de-99d3-0019e336be3a',
                               u'Eastern Africa'),
                              (u'e60b420e-88d2-11de-99d3-0019e336be3a',
                               u'Middle Africa'),
                              (u'e6d3af00-88d2-11de-99d3-0019e336be3a',
                               u'Southern Africa'),
                              (u'e89dc6f4-88d2-11de-99d3-0019e336be3a',
                               u'Western Africa'),
                              (u'e675a82e-88d2-11de-99d3-0019e336be3a',
                               u'Northern Africa')),
               'type': 'union'},
'country': u'Africa',
'uuid': u'2f693dc6-7e28-11de-9820-0019e336be3a'},
{'uuid': u'fe0113e8-7e2d-11de-9820-0019e336be3a',
  'country': u'Nordic Countries Power Association',
  'components': {'type':'union', 
  'buffer': 0.0001,
  'components': ((u'0d512a50-7d7e-11de-9ae2-0019e336be3a', u'Finland'),
   (u'10f1ec30-7d7e-11de-9ae2-0019e336be3a', u'Norway'),
   (u'1301c428-7d7e-11de-9ae2-0019e336be3a', u'Sweden'),
   (u'', u'NCPA Denmark'))}},
{'uuid': u'0723d252-7e2a-11de-9820-0019e336be3a',
  'country': u'Europe',
  'components': {'type': 'union',
  'buffer': 0.0001,
  'components': (
   (u'454039ee-211e-11df-8c13-0019e336be3a',
   u'European Kazakhstan, Azerbaijan, Georgia, Turkey'),
   (u'f030472a-e0b1-11de-882d-0019e336be3a', u'European Russia'),
   (u'097c2556-7d7e-11de-9ae2-0019e336be3a', u'Albania'),
   (u'10033c48-7d7e-11de-9ae2-0019e336be3a', u'Andorra'),
   (u'0d3f4416-7d7e-11de-9ae2-0019e336be3a', u'Austria'),
   (u'0f405034-7d7e-11de-9ae2-0019e336be3a', u'Belarus'),
   (u'0ff33cbc-7d7e-11de-9ae2-0019e336be3a', u'Belgium'),
   (u'09f7dc00-7d7e-11de-9ae2-0019e336be3a', u'Bosnia and Herzegovina'),
   (u'0a46f524-7d7e-11de-9ae2-0019e336be3a', u'Bulgaria'),
   (u'0e4ef37e-7d7e-11de-9ae2-0019e336be3a', u'Croatia'),
   (u'0d45a5d6-7d7e-11de-9ae2-0019e336be3a', u'Czech Republic'),
   (u'0cf950f0-7d7e-11de-9ae2-0019e336be3a', u'Denmark'),
   (u'0d28a62a-7d7e-11de-9ae2-0019e336be3a', u'Estonia'),
   (u'0fff8e5e-7d7e-11de-9ae2-0019e336be3a', u'Faroe Islands'),
   (u'0d512a50-7d7e-11de-9ae2-0019e336be3a', u'Finland'),
   (u'0d751636-7d7e-11de-9ae2-0019e336be3a', u'France'),
   (u'0e0e1020-7d7e-11de-9ae2-0019e336be3a', u'Germany'),
   (u'10061efe-7d7e-11de-9ae2-0019e336be3a', u'Gibraltar'),
   (u'0e22b962-7d7e-11de-9ae2-0019e336be3a', u'Greece'),
   (u'1541988a-7d7e-11de-9ae2-0019e336be3a', u'Guernsey'),
   (u'15265aa2-7d7e-11de-9ae2-0019e336be3a', u'Holy See (Vatican City State)'),
   (u'0e56bc44-7d7e-11de-9ae2-0019e336be3a', u'Hungary'),
   (u'0e5d5856-7d7e-11de-9ae2-0019e336be3a', u'Iceland'),
   (u'0d1de104-7d7e-11de-9ae2-0019e336be3a', u'Ireland'),
   (u'1009d666-7d7e-11de-9ae2-0019e336be3a', u'Isle of Man'),
   (u'0ebb28b4-7d7e-11de-9ae2-0019e336be3a', u'Italy'),
   (u'1544d680-7d7e-11de-9ae2-0019e336be3a', u'Jersey'),
   (u'0f3a36f4-7d7e-11de-9ae2-0019e336be3a', u'Latvia'),
   (u'0f55e480-7d7e-11de-9ae2-0019e336be3a', u'Liechtenstein'),
   (u'0f46d4ea-7d7e-11de-9ae2-0019e336be3a', u'Lithuania'),
   (u'100cd4b0-7d7e-11de-9ae2-0019e336be3a', u'Luxembourg'),
   (u'0f78e944-7d7e-11de-9ae2-0019e336be3a', u'Macedonia, the Former Yugoslav Republic of'),
   (u'0f9402ce-7d7e-11de-9ae2-0019e336be3a', u'Malta'),
   (u'1188faee-7d7e-11de-9ae2-0019e336be3a', u'Moldova, Republic of'),
   (u'1013310c-7d7e-11de-9ae2-0019e336be3a', u'Monaco'),
   (u'101cf458-7d7e-11de-9ae2-0019e336be3a', u'Montenegro'),
   (u'10df2fe6-7d7e-11de-9ae2-0019e336be3a', u'Netherlands'),
   (u'10f1ec30-7d7e-11de-9ae2-0019e336be3a', u'Norway'),
   (u'114ebb04-7d7e-11de-9ae2-0019e336be3a', u'Poland'),
   (u'115c647a-7d7e-11de-9ae2-0019e336be3a', u'Portugal'),
   (u'11813638-7d7e-11de-9ae2-0019e336be3a', u'Romania'),
   (u'15146d88-7d7e-11de-9ae2-0019e336be3a', u'San Marino'),
   (u'1520c2a4-7d7e-11de-9ae2-0019e336be3a', u'Serbia'),
   (u'0f515f00-7d7e-11de-9ae2-0019e336be3a', u'Slovakia'),
   (u'12d0bd4c-7d7e-11de-9ae2-0019e336be3a', u'Slovenia'),
   (u'12ea642c-7d7e-11de-9ae2-0019e336be3a', u'Spain'),
   (u'152d7e40-7d7e-11de-9ae2-0019e336be3a', u'Svalbard and Jan Mayen'),
   (u'1301c428-7d7e-11de-9ae2-0019e336be3a', u'Sweden'),
   (u'131278d6-7d7e-11de-9ae2-0019e336be3a', u'Switzerland'),
   (u'1387ef8a-7d7e-11de-9ae2-0019e336be3a', u'Ukraine'),
   (u'13725fee-7d7e-11de-9ae2-0019e336be3a', u'United Kingdom'),
   (u'1023d322-7d7e-11de-9ae2-0019e336be3a', u'Åland Islands'))}},
)

def process_shape(obj, shape=None):
    if obj['type'] == 'simple':
        assert not shape
        return Geography.objects.get(uuid=obj['components'][0]).shape
    elif obj['type'] == 'difference':
        assert shape
        return shape.difference(Geography.objects.get(
            uuid=obj['components'][0]).shape)
    elif obj['type'] == 'intersection':
        assert shape
        return shape.intersection(Geography.objects.get(
            uuid=obj['components'][0]).shape)
    if obj['type'] == 'union':
        assert not shape
        qs = [x[0] for x in obj['components']]
        return merge_polygons(Geography.objects.filter(uuid__in=qs), 
            buf=obj['buffer'])

for sequence in (step_one, step_two):
    for definition in sequence:
        uuid = definition['uuid']
        country_name = definition['country']
        print country_name
        objs = definition['components']
        modified_obj = Geography.objects.get(uuid=uuid, geography=country_name)
        if isinstance(objs, tuple):
            shape = None
            for obj in objs:
                shape = process_shape(obj, shape)
        else:
            shape = process_shape(objs)
        modified_obj.shape = shape
        modified_obj.save()
        modified_obj.create_simplified_shape()


# Global                                          GLO     1942    *unchanged*                         
# Oceanic                                         OCE     16      Offshore                            Renamed to avoid confusion with Oceania. No geographic information.
# Region 2
# Africa                                          RAF     1 [#]_  *unchanged*                         UN region Africa

# Region 142
# Asia and the Pacific                            RAS     3 [#]_  Asia                                Replace with UN region Asia

# Region 150
# Europe                                          RER     1258    *unchanged*                         UN region Europe

# Subregion 29
# Latin America & the Caribbean                   RLA     5 [#]_  *unchanged*                         UN Subregion Latin America and the Caribbean

# Subregion 21
# North America                                   RNA     13 [#]_ *unchanged*                         UN Subregion North Africa

# Near East                                       RNE     0       **deleted**

# Custom - what countries?
# Middle East                                     RME     1 [#]_  *unchanged*                         Custom geographic shape

# Western Europe                                  WEU     5 [#]_  **deleted**                         Move chemicals to Europe, and coal to appropriate subregion
# Pacific OECD [#]_                               PAO     0       **deleted**

# Subregion 151
# Independent States of the Former Soviet Union   FSU     0       Commonwealth of Independent States  UN Economic Subregion Commonwealth of Independent States

# Central and Eastern Europe                      EEU     2 [#]_  **deleted**                         Split into separate processes for Central Europe and Eastern Europe

# Middle East and North Africa                    MEA     0       **deleted**
# Sub-Saharan Africa                              AFR     0       **deleted**
# Centrally Planned Asia and China                CPA     2 [#]_  **deleted**                         Move to China.
# Other Pacific Asia                              PAS     0       **deleted**

# Subregion 35
# South Asia                                      SAS     0       *unchanged*                         UN Subregion South Asia

# Union for the Co-ordination of ...              UCTE    25      *unchanged*                         Custom geographic shape
# Central european power association              CENTREL 9       *unchanged*                         Custom geographic shape
# Nordic countries power association              NORDEL  21      *unchanged*                         Custom geographic shape
