from datetime import datetime
from brightway.apps.geo.models import Geography
from brightway.apps.inventory.models import Process
from brightway.apps.impact_assessment.models import Method, Weighting
from pyExcelerator import parse_xls

def import_weightings(excelfile, database,
        method,
        process,
        xls_ident_column=0,
        xls_data_column=1,
        xls_start_row=2,
        xls_end_row=None,
        xls_worksheet=0):

    xls = parse_xls(excelfile)
    geography_qset = Geography.objects.filter(database__database=database)

    xls_data = xls[xls_worksheet][1]

    if xls_end_row is None:
        idx = [i[0] for i in xls_data.keys()]
        idx.sort()
        xls_end_row = idx[-1]

    for row in range(xls_start_row, xls_end_row):
        try:
            geography = geography_qset.filter(db_internal_code=str(int(xls_data[(row, xls_ident_column)])))[0]
        except IndexError:
            continue

        method.weighting_set.create(
            record=process,
            geography=geography,
            amount=float(xls_data[(row, xls_data_column)]),
            creator=method.creator,
            modifier=method.modifier,
            created=datetime.now(),
            modified=datetime.now())

    # create() bypasses the save method. We still need to update the modified timestamp
    # because of the caches
    method.modified = datetime.now()

    return method, process
