from django.contrib.contenttypes.models import ContentType
from django.http import HttpResponse 
from brightway.io.export.generic_model_export import GenericModelExporter
from brightway.io.export.process_export import ProcessExporter
from brightway.apps.inventory.models import Process

def generic_export(request, app_label, model_string, export_type=None):
    model = ContentType.objects.get(app_label=app_label, 
        model=model_string).model_class()
    objs = model.objects.filter(pk__in=request.GET['ids'].split(","))
    g = GenericModelExporter(objs, format=export_type)
    g.export()
    return g.file_sender.send()

def export_process(request, export_type=None):
    if not export_type:
        export_type = "csv"
    objs = Process.objects.filter(pk__in=request.GET['ids'].split(","))
    exporter = ProcessExporter(objs, format=export_type)
    exporter.export()
    return exporter.file_sender.send()
