# -*- coding: utf-8 -*-
# Extra settings specific to Brightway
import os
import sys
BRIGHTWAY_ROOT_PATH = os.path.realpath(
    os.path.join(
        os.path.dirname(__file__), 
        '..'
    )
)
if sys.path[0] != BRIGHTWAY_ROOT_PATH:
    # settings.py is executed twice (!) by Django
    sys.path.insert(0, BRIGHTWAY_ROOT_PATH)

# Add settings
SETTINGS_FILES = (
    'generic.py',
    'main.py',
    'logging.py',
    'local.py',
)

for filename in SETTINGS_FILES:
    try:
        execfile(os.path.join(BRIGHTWAY_ROOT_PATH, 'settings', filename))
    except IOError:
        print "Couldn't find settings file %s" % filename
        raise

for plugin in filter(lambda x: x.split(".")[0:2] == ['brightway', 
        'plugins'], INSTALLED_APPS):
    name = plugin.split(".")
    if len(name) != 3:
        from django.core.management.color import color_style
        error_msg = "Plugins must have simple paths, e.g. plugins.foo." +\
            "\nPlugin %s has a complex path" % plugin
        sys.stderr.write(color_style().ERROR(str(error_msg)))
        continue
    path = os.path.join(BRIGHTWAY_ROOT_PATH, 
        'plugins', name[-1])
    try:
        execfile(os.path.join(path, 'local_settings.py'))
    except IOError:
        from django.core.management.color import color_style
        error_msg = "Failed to find local_settings for plugin " + \
            "'%s'.\nSearched in path: '%s'." % (name[-1], path)
        sys.stderr.write(color_style().ERROR(str(error_msg)))

if DEBUG:
    TASTYPIE_FULL_DEBUG = True
