# -*- coding: utf-8 -*-
# Generic values for all Brightway installations - Django specific
DEBUG = False

MANAGERS = ADMINS = ()

# Local time zone for this installation. All choices can be found here:
# http://www.postgresql.org/docs/current/static/datetime-keywords.html#DATETIME-TIMEZONE-SET-TABLE
TIME_ZONE = 'Europe/Zurich'

# Language code for this installation. All choices can be found here:
# http://www.w3.org/TR/REC-html40/struct/dirlang.html#langcodes
LANGUAGE_CODE = 'en-us'
LANGUAGES = ()
LOCALE_PATHS = ()
USE_I18N = False

SITE_ID = 1

DJANGO_SETTINGS_MODULE = 'settings'

# Absolute path to the directory that holds media.
MEDIA_ROOT = BRIGHTWAY_ROOT_PATH + '/media/dynamic/'

# Absolute path to the directory that holds static files.
STATIC_ROOT = BRIGHTWAY_ROOT_PATH + '/media/static/'

# URLs that handles the dynamic and static media served from MEDIA_ROOT.
MEDIA_URL = '/dynamic/'
STATIC_URL = '/static/'

# URL prefix for admin media -- CSS, JavaScript and images. Make sure to use a
# trailing slash.
# Examples: "http://foo.com/media/", "/media/".
ADMIN_MEDIA_PREFIX = '/media/static/admin/'

# List of callables that know how to import templates from various sources.
TEMPLATE_LOADERS = (
    'django.template.loaders.filesystem.Loader',
    'django.template.loaders.app_directories.Loader',
)

MIDDLEWARE_CLASSES = (
    'django.contrib.csrf.middleware.CsrfMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.middleware.doc.XViewMiddleware',
    'django.middleware.transaction.TransactionMiddleware',
)

ROOT_URLCONF = 'brightway.urls'

TEMPLATE_DIRS = (
    os.path.join(BRIGHTWAY_ROOT_PATH, 'apps/base/templates')+'/',
)

TEMPLATE_CONTEXT_PROCESSORS = (
    'django.contrib.auth.context_processors.auth',
    'django.core.context_processors.media',
    'django.core.context_processors.static',
    'django.core.context_processors.request',
)