import os

_LOGGING_ROOT = os.path.realpath(os.path.join(os.path.dirname(__file__), 
    '..', 'var', 'logs'))

LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'verbose': {
            'format': '%(levelname)s %(asctime)s %(lineno)d %(message)s'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'cache': {
            'level':'WARNING',
            'class':'logging.handlers.RotatingFileHandler',
            'formatter': 'verbose',
            'filename': os.path.join(_LOGGING_ROOT, 'cache.log'),
            'encoding': 'utf-8',
            'backupCount': 5,
        },
        'assessment': {
            'level':'WARNING',
            'class':'logging.handlers.RotatingFileHandler',
            'formatter': 'verbose',
            'filename': os.path.join(_LOGGING_ROOT, 'assessment.log'),
            'encoding': 'utf-8',
            'backupCount': 5,
        },
        'timing': {
            'level':'DEBUG',
            'class':'logging.handlers.RotatingFileHandler',
            'formatter': 'simple',
            'filename': os.path.join(_LOGGING_ROOT, 'timing.log'),
            'encoding': 'utf-8',
            'backupCount': 5,
        },
        'test': {
            'level':'INFO',
            'class':'logging.handlers.RotatingFileHandler',
            'formatter': 'simple',
            'filename': os.path.join(_LOGGING_ROOT, 'tests.log'),
            'encoding': 'utf-8',
            'backupCount': 5,
        },
        'access': {
            'level':'INFO',
            'class':'logging.handlers.RotatingFileHandler',
            'formatter': 'simple',
            'filename': os.path.join(_LOGGING_ROOT, 'access.log'),
            'encoding': 'utf-8',
            'backupCount': 5,
        },
    },
    'loggers': {
        'bw.cache': {
            'handlers':['cache', 'timing'],
            'propagate': True,
            'level':'INFO',
        },
        'bw.assessment': {
            'handlers':['assessment', 'timing'],
            'propagate': True,
            'level':'INFO',
        },
    }
}