# -*- coding: utf-8 -*-
# Main configuration values for Brightway

CACHE_BACKEND = 'dummy:///'

INSTALLED_APPS = (
    # Test fixtures
    'brightway.tests',

    # Apps
    'brightway.apps.base',
    'brightway.apps.data_source',
    'brightway.apps.geo',
    'brightway.apps.group_permissions',
    'brightway.apps.impact_assessment',
    'brightway.apps.inventory',
    'brightway.apps.license',
    'brightway.apps.parameter',
    'brightway.apps.unit',
    'brightway.apps.users',

    # Django
    'django.contrib.admin',
    'django.contrib.admindocs',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.sites',

    # Other apps
    'django_dag',
    'bw_attributes',
    'django_nose',
    'mptt',
)

### LCA Caching ###
BRIGHTWAY_RELATIVE_CACHE_PATH = 'var/cache' # Should be below root path
BRIGHTWAY_CACHE_PATH = os.path.join(BRIGHTWAY_ROOT_PATH,
    BRIGHTWAY_RELATIVE_CACHE_PATH)

AUTHENTICATION_BACKENDS = (
    'django.contrib.auth.backends.ModelBackend'
)