import os
from random import choice

TEMPLATE = """# -*- coding: utf-8 -*-
DEBUG=False

# Make this unique, and don't share it with anybody.
SECRET_KEY = '%s'

# Override to change defaults
# MEDIA_URL = '/media/'
# STATIC_URL = "/static/"

# Uncomment if you have a Google Analytics account
# GOOGLE_ANALYTICS = "1"
# Disqus provides comments
# DISQUS_WEBSITE_SHORTNAME = None

EMAIL_HOST = 'smtp.gmail.com' # Change if not using gmail account
EMAIL_HOST_USER = 'YOUR USERNAME'
EMAIL_HOST_PASSWORD = 'YOUR PASSWORD'
EMAIL_PORT = 587
EMAIL_USE_TLS = True
SERVER_EMAIL = DEFAULT_FROM_EMAIL = EMAIL_HOST_USER

DATABASES = {
   'default' : {
       'ENGINE' : 'django.db.backends.postgresql_psycopg2',
       'NAME' : 'DB NAME',
       'USER' : 'YOUR USERNAME',
       'PASSWORD': 'YOUR PASSWORD'
   },
}

ADMINS = (
     ('YOUR NAME', 'YOUR EMAIL'),
)

CACHE_BACKEND = 'locmem:///'

# Uncomment to have tests drop into PDB upon failure
# NOSE_ARGS = ['--pdb',]

# If running across domains
# SESSION_COOKIE_DOMAIN=".yourdomain.com"
"""

def get_new_secret_key():
    return ''.join([choice( 
        'abcdefghijklmnopqrstuvwxyz0123456789!@#$%^&*(-_=+)' ) for i in \
        range(50)])

settings_dir = os.path.join(os.path.dirname(__file__), "..", "..", "settings")
settings = TEMPLATE % get_new_secret_key()

if "local.py" in os.listdir(settings_dir):
    with open(os.path.join(settings_dir, "local.py"), "r") as f_backup:
        with open(os.path.join(settings_dir, "local.py.backup"), "w") as f:
            for line in f_backup:
                f.write(line)

with open(os.path.join(settings_dir, "local.py"), "w") as f:
    f.write(settings)

try:
    os.system("cd core/io && hg clone https://bitbucket.org/cmutel/brightway-data data")
except:
    print """Can't retrieve Brightway input data. Please change to the 'core/io' directory and run this command:

    hg clone https://bitbucket.org/cmutel/brightway-data data"""
