import os
import bz2
from django.conf import settings
from brightway.core import create_defaults
from brightway.io.imprt.ecospold_ia_import import \
    EcospoldImpactAssessmentImporter
from brightway.io.imprt.ecospold_import import Ecospold1Importer
from brightway.io.data.scripts import UnitImport, GeographyImport, \
    LicenseImport, BiosphereFlowImport
from brightway.apps.inventory.models import Database
from brightway.apps.geo.models import Geography

data_dir = os.path.join(settings.BRIGHTWAY_ROOT_PATH, 
    "core/tests/db/data/")
print "Defaults"
create_defaults()
print "Units & Licenses"
UnitImport()
LicenseImport()
print "Geographies"
GeographyImport()
# Don't care about geo definitions for calculation tests
Geography.objects.update(poly_shape=None, shape_type=0)
print "Flows"
BiosphereFlowImport()
print "Open IO"
process_mapping = {
	'Propane, 1,1,1,3,3,3-hexafluoro-, HCFC-236fa': 'Propane', 
	'Methane, tetrafluoro-, CFC-14': "Methane, tetrafluoro-, R-14"
}
Ecospold1Importer(os.path.join(data_dir, "openio"), "open IO 4", 
    parent_databases=Database.objects.filter(database="biosphere flows"), 
    add_categories=False, add_processes=True, add_exchanges=True,
    commit=True, show_progress=True, process_mapping=process_mapping)
print "IA methods"
bf = Database.objects.get(database='biosphere flows')
for filename in filter(lambda x: x.lower()[-4:] == ".xml", 
        os.listdir(os.path.join(data_dir, "ia"))):
    filepath = os.path.join(data_dir, "ia", filename)
    EcospoldImpactAssessmentImporter(filepath, bf)

