from django.conf import settings
from django.core.management import call_command
from django.db.models import loading
from brightway.tests.base_test_case import BaseTestCase

class ExtraAppsTestCase(BaseTestCase):
    """Test case that allows test apps to be added to INSTALLED_APPS. Useful for simple apps that don't need/want the whole lca test case."""
    apps = ()

    def _pre_setup(self):
        # Add the models to the db.
        self._original_installed_apps = list(settings.INSTALLED_APPS)
        for app in self.apps:
            settings.INSTALLED_APPS.append(app)
        loading.cache.loaded = False
        call_command('syncdb', interactive=False, verbosity=1)
        # Call the original method that does the fixtures etc.
        super(ExtraAppsTestCase, self)._pre_setup()

    def _post_teardown(self):
        # Call the original method.
        super(ExtraAppsTestCase, self)._post_teardown()
        # Restore the settings.
        settings.INSTALLED_APPS = self._original_installed_apps
        loading.cache.loaded = False

