from django.conf.urls.defaults import *
from django.contrib import admin
from django.conf import settings
import brightway.apps.base.admin_actions # Add custom admin actions
admin.autodiscover()

urlpatterns = patterns('',
    # Admin
    (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    (r'^admin/', include(admin.site.urls)),

    # Export
    (r'^export/special/process/', 
        'brightway.io.views.export_process', {}, 
        'export_process_csv'),
    (r'^export/special/process/(?P<export_type>csv|tsv|excel)/', 
        'brightway.io.views.export_process', {}, 
        'export_process'),
    (r'^export/(?P<app_label>\w+)/(?P<model_string>\w+)/', 
        'brightway.io.views.generic_export', {'export_type': 'csv'}, 
        'generic_export_csv'),
    (r'^export/(?P<app_label>\w+)/(?P<model_string>\w+)/(?P<export_type>csv|tsv|excel)/', 
        'brightway.io.views.generic_export', {}, 'generic_export'),
    )

if settings.DEBUG:
    urlpatterns += patterns('',
        (r'^media/(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),
        (r'^static/(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),
    )
